#include <amxmodx>
#include <codmod>
#include <engine>
#include <cstrike>
#include <fun>
#include <dhudmessage>
#include <colorchat>

native cod_set_perk_durability(id, wytrzymalosc); // Ustawia wytrzymalosc perku gracza.
native cod_get_perk_durability(id); // Pobiera wytrzymalosc perku gracza.

native cod_set_user_coins(id, wartosc);
native cod_get_user_coins(id);

new defuse, tramal, amfetamina, lotto, doswiadczenie, ruletka, naprawa, tramhp, expmin, expmax, wytrzymalosc;
new Float:gravity;

public plugin_init() 
{
	register_plugin("CodShop by MieTeK", "1.2", "MieTeK");
	
	register_clcmd("say /sklep", "Sklep");
	
	// Cvary
	register_cvar("shop_defuse", "1");
	register_cvar("shop_tramal", "5");
	register_cvar("shop_amfetamina", "6");
	register_cvar("shop_lotto", "12");
	register_cvar("shop_doswiadczenie", "15");
	register_cvar("shop_ruletka", "8");
	register_cvar("shop_naprawa", "10");
	register_cvar("shop_tramhp", "50");
	register_cvar("shop_gravity", "0.50");
	register_cvar("shop_expmin", "25");
	register_cvar("shop_expmax", "250");
	register_cvar("shop_wytrzymalosc", "15");
	
}

public client_authorized(id) 
{ 
	client_cmd(id,"bind ^"v^" ^"say /sklep^"") 
}

public Sklep(id)
{
	// Pobieranie cvar
	defuse = get_cvar_num("shop_defuse");
	tramal = get_cvar_num("shop_tramal");
	amfetamina = get_cvar_num("shop_amfetamina");
	lotto = get_cvar_num("shop_lotto");
	doswiadczenie = get_cvar_num("shop_doswiadczenie");
	ruletka = get_cvar_num("shop_ruletka");
	naprawa = get_cvar_num("shop_naprawa");
	tramhp = get_cvar_num("shop_tramhp");
	gravity = get_cvar_float("shop_gravity");
	expmin = get_cvar_num("shop_expmin");
	expmax = get_cvar_num("shop_expmax");
	wytrzymalosc = get_cvar_num("shop_wytrzymalosc");
	
	new tytul[25], def[65], tra[65], amf[65], lot[65], dos[65], rul[65], nap[65];
	format(tytul, 24, "\w.:: Cod EvolutioN ::.");
	formatex(def, 64, "Defuse \r[Tylko dla CT] \yKoszt:\r 1M", defuse);
	formatex(tra, 64, "Amfetamina \r[Leczy %i HP] \yKoszt:\r 5M", tramhp, tramal);
	formatex(amf, 64, "Redbull \r[Wyzej skaczesz] \yKoszt:\r 6M", amfetamina);
	formatex(lot, 64, "Lotto \r[Losowanie bonusow] \yKoszt:\r 12M", lotto);
	formatex(dos, 64, "Doswiadczenie \r[Dostajesz losowy EXP] \yKoszt:\r 15M", doswiadczenie);
	formatex(rul, 64, "Ruletka \r[Dostajesz losowy perk] \yKoszt:\r 8M", ruletka);
	formatex(nap, 64, "Naprawa Itemu \r[+%i do wytrzymalosci itemu] \yKoszt:\r 10M", wytrzymalosc, naprawa);
	
	new menu = menu_create(tytul, "Sklep_Handler");
	menu_additem(menu, def, "1");
	menu_additem(menu, tra, "1");
	menu_additem(menu, amf, "1");
	menu_additem(menu, lot, "1");
	menu_additem(menu, dos, "1");
	menu_additem(menu, rul, "1");
	menu_additem(menu, nap, "1");
	menu_setprop(menu, MPROP_EXITNAME,"Wyjdz")
	menu_display(id, menu,0);
}

public Sklep_Handler(id, menu, item)
{
	
	if(!is_user_alive(id) || !is_user_connected(id))
		return PLUGIN_CONTINUE;
	
	new zdrowie = get_user_health(id);
	new kasa = cod_get_user_coins(id)
	new maxzdrowie = cod_get_user_health(id)+100
	
	if(item == MENU_EXIT)
	{
		menu_destroy(menu);
		return PLUGIN_CONTINUE;
	}
	
	switch(item)
	{
		case 0:
		{
        if(get_user_team(id) == 2){
                if(cs_get_user_defuse(id) == 1){
                        ColorChat(id, GREEN, "[Cod|Evo]^x01 Posiadasz juz defuse!");
                        return PLUGIN_HANDLED;
                }
                if(kasa >= 1){
                        cs_set_user_defuse(id, 1, 0, 160, 0, "defuser", 1)
                        cod_set_user_coins(id, kasa-1);
                        return PLUGIN_HANDLED;		
                }
                else {
                        ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
                }
        }
        else {
                ColorChat(id, GREEN, "[Cod|Evo]^x01 Tylko CT moze kupic defuse!")
        }
        return PLUGIN_CONTINUE;
		}
		case 1:
		{
			if(kasa >= 5)
			{
				new nowe_zdrowie = (zdrowie+tramhp);
				if(nowe_zdrowie < maxzdrowie)
				{
					cod_set_user_coins(id, kasa-5);
					set_user_health(id, nowe_zdrowie);
					ColorChat(id, GREEN, "[Cod|Evo]^x01 Uleczono Cie o ^x01%i^x03 hp!", tramhp);
				}
				if(nowe_zdrowie >= maxzdrowie && zdrowie != maxzdrowie)
				{
					cod_set_user_coins(id, kasa-5);
					set_user_health(id, maxzdrowie);
					ColorChat(id, GREEN, "[Cod|Evo]^x01 Jestes w pelni uleczony!");
				}
			}
			else
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
		}
		case 2:
		{
			if(kasa >= 6)
			{
				cod_set_user_coins(id, kasa-6);
				set_user_gravity(id, gravity);
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Skaczesz wyzej!");
			}
			else
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
		}
		case 3:
		{

			if(kasa >= 12)
			{
				cod_set_user_coins(id, kasa-12);
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Trwa losowanie!");
				new totek = random_num(0, 10);
				
				switch(totek)
				{
					case 1:
					{
						set_user_gravity(id, get_user_gravity(id)-0.3);
						ColorChat(id, GREEN, "[Cod|Evo]^x01 Wygrales nizsza grawitacje!");
					}
					case 2:
						ColorChat(id, GREEN, "[Cod|Evo]^x01 Niestety nic nie wygrales!");
					case 3:
					{
						new bonusxp = random_num(expmin ,75);
						cod_set_user_xp(id, cod_get_user_xp(id)+bonusxp);
						ColorChat(id, GREEN, "[Cod|Evo]^x01 Wygrales ^x01%i^x03 dodatkowego EXP'a !", bonusxp);
					}
					case 4:
					{
						cod_set_user_perk(id, -1, -1, 1);
						ColorChat(id, GREEN, "[Cod|Evo] ^x03Wygrales losowy item!");
					}
					case 5:
					{
						new healthbonus = random_num(10,300);
						set_user_health(id, get_user_health(id)+healthbonus);
						ColorChat(id, GREEN, "[Cod|Evo]^x01 Wygrales ^x01%i^x03 dodatkowego HP!", healthbonus);
					}
					case 6:
						ColorChat(id, GREEN, "[Cod|Evo]^x01 Niestety nic nie wygrales !");
					case 7:
					{
						new xpbonus = random_num(75,expmax);
						cod_set_user_xp(id, cod_get_user_xp(id)+xpbonus);
						ColorChat(id, GREEN, "[Cod|Evo]^x01 Wygrales ^x01%i^x03 dodatkowego EXP'a!", xpbonus);
					}
						
				}
			}		
			else
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
		}
		case 4:
		{
			if(kasa >= 15)
			{
				new exp = cod_get_user_xp(id);
				new losowy = random_num(expmin, expmax);
				cod_set_user_coins(id, kasa-15);
				cod_set_user_xp(id, exp+losowy)
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Dostales ^x01%i^x03 EXP'a!", losowy);
			}
			else
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
		}
		case 5:
		{
			if(kasa >= 8)
			{
				cod_set_user_coins(id, kasa-8);
				cod_set_user_perk(id, -1, -1, 1);
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Kupiles losowy item!");
			}
			else
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
		}
		case 6:
		{
			if(kasa >= 10)
			{
				new uszkodzenia_perku = cod_get_perk_durability(id);
				if(uszkodzenia_perku+wytrzymalosc>=100)
				{
					cod_set_perk_durability(id, 100);
					ColorChat(id, GREEN, "[Cod|Evo]^x01 Twoj item jest w pelni naprawiony!", cod_get_perk_durability(id));
				}
				else
				{
					cod_set_perk_durability(id, uszkodzenia_perku+wytrzymalosc);
					ColorChat(id, GREEN, "[Cod|Evo]^x01 Kupiles ^x01+%i^x03 wytrzymalosci itemu!", wytrzymalosc);
					ColorChat(id, GREEN, "[Cod|Evo]^x01 Wytrzymalosc twojego itemu wynosi ^x01%i", cod_get_perk_durability(id));
				}
				cod_set_user_coins(id, kasa-10);
			}
			else
				ColorChat(id, GREEN, "[Cod|Evo]^x01 Masz za malo monet!");
		}
				
	}
	
	return PLUGIN_CONTINUE;
}
